<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleGeozonesResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleGeozonesResult extends AbstractStructArrayBase
{
    /**
     * The VehicleGeozonesResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleGeozonesResult[]
     */
    public $VehicleGeozonesResult;
    /**
     * Constructor method for ArrayOfVehicleGeozonesResult
     * @uses ArrayOfVehicleGeozonesResult::setVehicleGeozonesResult()
     * @param \StructType\VehicleGeozonesResult[] $vehicleGeozonesResult
     */
    public function __construct(array $vehicleGeozonesResult = array())
    {
        $this
            ->setVehicleGeozonesResult($vehicleGeozonesResult);
    }
    /**
     * Get VehicleGeozonesResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleGeozonesResult[]|null
     */
    public function getVehicleGeozonesResult()
    {
        return isset($this->VehicleGeozonesResult) ? $this->VehicleGeozonesResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleGeozonesResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleGeozonesResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleGeozonesResultForArrayConstraintsFromSetVehicleGeozonesResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleGeozonesResultVehicleGeozonesResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleGeozonesResultVehicleGeozonesResultItem instanceof \StructType\VehicleGeozonesResult) {
                $invalidValues[] = is_object($arrayOfVehicleGeozonesResultVehicleGeozonesResultItem) ? get_class($arrayOfVehicleGeozonesResultVehicleGeozonesResultItem) : sprintf('%s(%s)', gettype($arrayOfVehicleGeozonesResultVehicleGeozonesResultItem), var_export($arrayOfVehicleGeozonesResultVehicleGeozonesResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleGeozonesResult property can only contain items of type \StructType\VehicleGeozonesResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleGeozonesResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleGeozonesResult[] $vehicleGeozonesResult
     * @return \ArrayType\ArrayOfVehicleGeozonesResult
     */
    public function setVehicleGeozonesResult(array $vehicleGeozonesResult = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleGeozonesResultArrayErrorMessage = self::validateVehicleGeozonesResultForArrayConstraintsFromSetVehicleGeozonesResult($vehicleGeozonesResult))) {
            throw new \InvalidArgumentException($vehicleGeozonesResultArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleGeozonesResult) || (is_array($vehicleGeozonesResult) && empty($vehicleGeozonesResult))) {
            unset($this->VehicleGeozonesResult);
        } else {
            $this->VehicleGeozonesResult = $vehicleGeozonesResult;
        }
        return $this;
    }
    /**
     * Add item to VehicleGeozonesResult value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleGeozonesResult $item
     * @return \ArrayType\ArrayOfVehicleGeozonesResult
     */
    public function addToVehicleGeozonesResult(\StructType\VehicleGeozonesResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleGeozonesResult) {
            throw new \InvalidArgumentException(sprintf('The VehicleGeozonesResult property can only contain items of type \StructType\VehicleGeozonesResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleGeozonesResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleGeozonesResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleGeozonesResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleGeozonesResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleGeozonesResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleGeozonesResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleGeozonesResult
     */
    public function getAttributeName()
    {
        return 'VehicleGeozonesResult';
    }
}
